
io.stdout:setvbuf "no"
Sleep = require "sleep"
Tween = require "tween"
--[[
when hit() is called:
	deal_tween: created when a card is dealt from d to h; 
	Sleep.love.keypressed(duration, dream): dream replaces keypressed for duration
]]


--/*-----------------------------------*/--
--  -------------MVC: MODEL------------  --
--/*-----------------------------------*/--
-- tables
local deck, hand -- deck/hand are both 1-index integer array and key-value table
local rank, suit -- 0-index string arrays
local cleared -- 1-index boolean array

-- functions
local hit, gameover, play, shuffle, getscore

-- integers
local CARD_A, CARD_B, score, cardsplayed
local card_points_val, clear_heart_bonus, clear_club_bonus, clear_diamond_bonus, clear_spade_bonus

--/*-----------------------------------*/--
--  -------------MVC: VIEW-------------  --
--/*-----------------------------------*/--
-- functions
local ui, deal

-- tables
local help_color
local stars
local images 

-- numbers
local wrapWidth

-- tweens
local help_color_tween, deal_tween

-- spriteBatch
local spriteBatch

--/*-----------------------------------*/--
--  -----------MVC: CONTROLLER---------  --
--/*-----------------------------------*/--
-- functions
local resize_ui, gameover_newgame, rules, resume_game, resize

-- tables
local game, newgame -- stores love callback functions
local colour -- 1-index number array
local col -- 0-index array of color arrays

-- Text
local ScoreText, HelpText -- Text

-- Fonts
local font_20, font_16 = love.graphics.newFont(20), love.graphics.newFont(16)

-- integer
local window_state

function logic()
	local Deck = {}
	for i=1,52 do Deck[i] = i end
	deck = Deck;

	hand = {}
	-- animations
	-- on mousepressed: tweens x,y,w,h so the card is a little smaller but still centered
	-- on mousereleased: tweens x,y,w,h to its original size, using backOut easing
	hit=function() if deck[1] then table.insert(hand, table.remove(deck))  if hand[17] then gameover() else return true end end end
	CARD_A=0
	CARD_B=0
	rank={[0]="A",'2','3','4','5','6','7','8','9','10','J','Q','K'}
	suit={[0]="Hearts","Clubs","Diamonds","Spades"}
	play=function() 
		if (CARD_B-CARD_A==1 or CARD_B-CARD_A==3) and (hand[CARD_A]%13==hand[CARD_B]%13 or hand[CARD_A]%4==hand[CARD_B]%4) then 
			r1=rank[hand[CARD_A]%13]			
			r2=rank[hand[CARD_B]%13]
			s1=suit[hand[CARD_A]%4]
			s2=suit[hand[CARD_B]%4]
			print(r1,s1)
			print(r2,s2)
			hand[CARD_A] = table.remove(hand,CARD_B)
			score, cardsplayed, cleared = getscore()
		end
		-- hand[ca]=table.remove(hand,cb) end
	end
	shuffle=function(n)
		n = n or 1
		local m = 1
		local rnd=math.random
		repeat
			for i=1,#deck do 
				local j=rnd(#deck) 
				deck[i],deck[j]=deck[j],deck[i]			
			end
			m = m + 1
		until m >= n
	end
	score = 0
	cardsplayed = 0
	cleared = {}
	card_points_val = 5
	clear_heart_bonus = 20
	clear_club_bonus = 30
	clear_diamond_bonus = 40
	clear_spade_bonus = 50

	function getscore()
		local score = 0
		local cards = 0
		local cleared = {}
		local heart, club, diamond, spade
		for i,v in ipairs(deck) do
			if v%4 == 0 then 
				heart=true
			elseif v%4 == 1 then
				club=true
			elseif v%4 == 2 then
				diamond=true
			elseif v%4 == 3 then
				spade=true
			end
			cards = i
		end
		for i,v in ipairs(hand) do
			if v%4 == 0 then 
				heart=true
			elseif v%4 == 1 then
				club=true
			elseif v%4 == 2 then
				diamond=true
			elseif v%4 == 3 then
				spade=true
			end
			cards = cards + 1
		end
		-- bonus points for clearing a suit
		score = not heart and score + clear_heart_bonus or score
		score = not club and score + clear_club_bonus or score
		score = not diamond and score + clear_diamond_bonus or score
		score = not spade and score + clear_spade_bonus or score
		score = score + (52 - cards) * card_points_val

		cleared = {not heart, not club, not diamond, not spade}

		cards = 52 - cards 
		return score, cards, cleared
	end
end

function ui()
	deck.x=0
	deck.y=0
	deck.w=70
	deck.h=98
	if not images then
		images = {}
		images[1] = love.graphics.newImage "images/rosecardproto1.png"
		if #images > 0 then
			spriteBatch = love.graphics.newSpriteBatch(images[1], #images)
		end
	end
		

	local xy={}
	local x,y=10,love.graphics.getHeight()
	local w=love.graphics.getWidth()-x*2

	local len=math.floor(w/deck.w)
	local _rows = math.ceil(16/len)
	local n=1
	repeat
		for i=0,len-1 do
			if n >16 then break end
			xy[n] = {x = x+deck.w*i, y = y-deck.h*_rows}
			xy[n].dx = 0
			xy[n].dy = 0
			xy[n].w = deck.w
			xy[n].h = deck.h

			xy[n].x2 = xy[n].x + 2
			xy[n].y2 = xy[n].y + 2
			xy[n].w2 = xy[n].w - 4
			xy[n].h2 = xy[n].h - 4

			xy[n].current_x = xy[n].x2
			xy[n].current_y = xy[n].y2
			xy[n].current_w = xy[n].w2
			xy[n].current_h = xy[n].h2
			n = n + 1
		end
		_rows = _rows - 1
	until _rows == 0
	hand.xy = xy
	hand.x = x

	hand.w=w

	help_color = {1,1,1,1}
	wrapWidth = love.graphics.getWidth()
	-- Error: main.lua:185: bad argument #2 to 'tween_sequence' (nil or table expected)
	-- local delay = tween_delay(4)
	-- help_color_tween_sequence = tween_sequence( delay, tween(6,  help_color,  {[4]=0}) )
	-- dont know what the above failed for, but here's the new version
	local delay = Tween.delay(10)
	local color_tween = Tween.new(2, help_color, {[4]=0}, linearTween)
	help_color_tween = Tween.sequence( delay, color_tween )


	function deal()
		hand.xy[#hand].dx=deck.x-hand.xy[#hand].x
		hand.xy[#hand].dy=deck.y-hand.xy[#hand].y

		if deal_tween then deal_tween:finish() deal_tween = nil end
		deal_tween = Tween.new(0.1, hand.xy[#hand], {dx=0,dy=0}, nil)

		Sleep.love.keypressed(0.1, function(k)
			if k=='escape' then love.event.quit() end
			if k=='return' then 
				deal_tween:finish()
				Sleep.love.keypressed(0)
			end
		end)
	end

	resize_ui(love.window.getMode())

end

function gameover()

	if deal_tween then
		deal_tween:finish()
		deal_tween = nil
	end if help_color_tween then
		help_color_tween = nil
	end
	deck = nil
	hand = nil
	Sleep.forceQuit()	-- All Sleep events end
	love.keypressed = function(k)
		if k=='escape' or k=='n' then love.event.quit() end
		if k=='y' then gameover_newgame() end
	end
	love.mousepressed = function() end
	love.mousereleased = function() end
	love.mousemoved = function() end
	love.wheelmoved = function() end
	colour = colour or {1,0,0,1}
	local r = - 0.005
	local g = 0.010
	local b = - 0.0075
	font_20 = font_20 or love.graphics.newFont(20)
	ScoreText = love.graphics.newText(font_20)
	local N = 0
	local y = font_20:getHeight() * font_20:getLineHeight()
	if cardsplayed >= 1 then
		ScoreText:add("Normal Matches: "..(cardsplayed * 5).." points", 0, y)
		N = N + 1
		y = y + ScoreText:getHeight(N)
	end if cleared[1] then
		ScoreText:add({{.75,0,.75,1},"Cleared all purple cards: 20 points"}, 0, y)
		N = N + 1
		y = y + ScoreText:getHeight(N)
	end if cleared[2] then
		ScoreText:add({{.75,.75,0,1},"Cleared all yellow cards: 30 points"}, 0, y)
		N = N + 1 
		y = y + ScoreText:getHeight(N)
	end if cleared[3] then
		ScoreText:add({{0,.75,0,1},"Cleared all green cards: 40 points"}, 0, y)
		N = N + 1
		y = y + ScoreText:getHeight(N)
	end if cleared[4] then
		ScoreText:add({{0,.75,.75,1},"Cleared all teal cards: 50 points"}, 0, y)
		N = N + 1
		y = y + ScoreText:getHeight(N)
	end

	love.draw = function()

		stars:draw()

		love.graphics.setColor(unpack(colour))
		love.graphics.setFont(font_20)

		love.graphics.print("Score: "..score, 0, 0)

		love.graphics.setColor(1,1,1,1)

		love.graphics.draw(ScoreText)

		love.graphics.print("Play Again?\n\tY/N", 0, y)
	end

	love.update = function(dt)

		stars:update(dt)

		colour[1] = colour[1] + r
		colour[2] = colour[2] + g
		colour[3] = colour[3] + b
		g = colour[2] > 1 and - g or colour[2] < 0 and - g or g
		r = colour[1] > 1 and - r or colour[1] < 0 and - r or r
		b = colour[3] > 1 and - b or colour[3] < 0 and - b or b

	end
end

function gameover_newgame()
	love.keypressed=newgame.keypressed
	love.update=newgame.update
	love.draw=newgame.draw
	love.mousepressed=newgame.mousepressed
	love.mousereleased=newgame.mousereleased
	love.mousemoved=newgame.mousemoved
	logic()
	ui()
	shuffle(7)
end
how_to_play = [[Accordion

How to play

Begin with the complete deck in your hand. Make piles by dealing out cards face up in a row, left to right, one card to a pile. Any pile can be picked up and moved onto the pile to its left, or the pile third to its left, provided the top cards of the piles match in either suit or rank. You must move entire piles, never partial piles. When you move a pile in the middle of the row, leaving an empty space, just shift all the other piles in to fill it. The goal is to finish the game with all the cards in one pile.

]] .. [[How to get points:

	Add a card to a pile: 5 points 
	Clear all Purple Cards: 20 points
	Clear all Yellow Cards: 30 points
	Clear all Green Cards: 40 points
	Clear all Teal Cards: 50 points]]

function rules()
	game = {
		keypressed = love.keypressed;
		update = love.update;
		draw = love.draw;
		mousepressed = love.mousepressed;
		mousereleased = love.mousereleased;
		mousemoved = love.mousemoved;
	}
	love.update = function(dt) stars:update(dt) end
	font_16 = font_16 or love.graphics.newFont(16)
	love.draw = function() 
		stars:draw()
		love.graphics.setFont(font_16) 
		love.graphics.setColor(1,1,1,1) 
		love.graphics.printf(how_to_play, 0, 0, wrapWidth, "left") 
	end
	love.keypressed = function(k) if k then resume_game() end end
	love.mousepressed = function() end
	love.mousereleased = function() resume_game() end
	love.mousemoved = function() end

	function resume_game()
		for k,v in pairs(game) do
			love[k] = v
		end
	end
end

function love.load()
	-- success = love.window.setMode( width, height, {resizable=true} )
	love.window.setMode(640,480,{fullscreen = false, resizable = true, highdpi = true})

	colour = colour or {1,0,0,1}
	logic()
	ui()
	shuffle(7)
	stars.init(stars)
	newgame={}
	newgame.keypressed=love.keypressed
	newgame.update=love.update
	newgame.draw=love.draw
	newgame.mousepressed=love.mousepressed
	newgame.mousemoved=love.mousemoved
	newgame.mousereleased=love.mousereleased

end


function love.resize()

end


	


stars = {w = 1034, h = 778}
stars.colors = {
	{0.8,0.8,0.8,0.8};
--[[	{0.4, 0.4, 0.4, 0.8};
	{0.5, 0.8, 0.2, 0.8};
	{0.8, 0.1, 0.5, 0.8};
	{0.3, 0.5, 0.8, 0.8};
	{0.1, 0.1, 0.9, 0.8};
	{0.4, 0.8, 0.2, 0.8};
--]]	background_color = {33/255, 41/255, 45/255, 1};
}
stars.stars = {
	{};
	{};
	{};
	{};
	{};
	{};
}
local x,y = 0, 0
local i = 1

function stars.init(self)
	print("stars", self.w, self.h)
	local rand = math.random
	repeat
		local speed = math.random() * 2-- max of 1000 frames to go across the screen
		local color = math.random(#self.colors)
		x = x + math.random(10, 100)
		table.insert(stars.stars[color], { x = x, y = y + math.random(100), speed = speed })
		if x > stars.w then 
			x = 0
			y = y + 110 
		end

		i = i + 1
	until (y > stars.h or i > 100)
end

function stars.draw(self)
	love.graphics.setBackgroundColor(unpack(self.colors.background_color))
	for i, color in ipairs(self.colors) do
		love.graphics.setColor(unpack(color))
		for _, star in ipairs(self.stars[i]) do
			love.graphics.rectangle('fill', star.x, star.y, 1, 1)
		end
	end
end

function stars.update(self, dt)
	for i, stars in ipairs(self.stars) do
		for i, v in ipairs(stars) do
			v.x = v.x + v.speed * dt
			-- v.y = v.y + v.speed * dt
			if v.x > self.w then v.x = -10 end
			-- if v.y > self.h then v.y = -10 end
		end
	end
end

function love.draw()

	--background and stars
	stars:draw()

	love.graphics.setFont(font_20)
	love.graphics.setColor(unpack(help_color))
	-- love.graphics.printf("Press r to see the rules, f to resize the window, e to end the game and see high scores. h to hit deck (deals card), escape to close the game.", 
	-- 	deck.x, deck.y + deck.h, wrapWidth, "left")
	love.graphics.draw(HelpText)

	-- deck
	love.graphics.setColor(unpack(colour))
	love.graphics.rectangle('fill',deck.x,deck.y,deck.w,deck.h,8,8,16)

	-- hand insets
	love.graphics.setColor(0.2,0.2,0.8,1.0)
	for i,v in ipairs(hand.xy) do
		love.graphics.rectangle('fill',v['x'],v['y'],deck.w,deck.h,8,8,16)
	end
	

	-- hand CARDS
	-- purple yellow green teal
	col = col or {[0]={.75,0,.75,1},{.75,.75,0,1},{0,.75,0,1},{0,.75,.75,1}}
	local prev
	for i,v in ipairs(hand) do
		
		if v%4 ~= prev then
			love.graphics.setColor(col[v%4])
			prev=v%4
		end
		-- current hand
		love.graphics.rectangle('fill',
			hand.xy[i]['current_x']+hand.xy[i].dx,
			hand.xy[i]['current_y']+hand.xy[i].dy,
			hand.xy[i]['current_w'],
			hand.xy[i]['current_h'],
			8,8,16)
		
	end
	
	-- hand CARD-OUTLINE. 
	-- Does not draw properly with currently selected card - i dont care
	-- because eventually i will have proper graphics
	love.graphics.setColor(0,0,0,1)
	love.graphics.setLineWidth(4)
	for i,v in ipairs(hand) do
		love.graphics.rectangle('line',
			hand.xy[i]['current_x']+hand.xy[i].dx,
			hand.xy[i]['current_y']+hand.xy[i].dy,
			hand.xy[i]['current_w'],
			hand.xy[i]['current_h'],
			8,8,16)
	end

	love.graphics.setColor(0.1,0.1,0.1,1)
	for i,v in ipairs(hand) do
		love.graphics.print(rank[v%13],hand.xy[i]['x']+hand.xy[i].dx+deck.w/2,hand.xy[i]['y']+hand.xy[i].dy+deck.h/2)
	end

	-- Currently Selected Card
	if CARD_B > 1 and CARD_B < #hand+1 then
		local i = CARD_B
		local v = hand[i]
		love.graphics.setColor(col[v%4])
		love.graphics.rectangle('fill',
			hand.xy[i]['current_x']+hand.xy[i].dx,
			hand.xy[i]['current_y']+hand.xy[i].dy,
			hand.xy[i]['current_w'],
			hand.xy[i]['current_h'],
			8,8,16)
		love.graphics.setColor(0.1,0.1,0.1,1)
		love.graphics.print(rank[v%13],hand.xy[i]['x']+hand.xy[i].dx+deck.w/2,hand.xy[i]['y']+hand.xy[i].dy+deck.h/2)
	end

	-- 
end

function love.update(dt)
	Sleep.update(dt)
	if deal_tween then deal_tween:update(dt) end
	if help_color_tween then help_color_tween:update(dt) end
	if card_tween then card_tween:update(dt) end
	stars:update(dt)
end




function love.keypressed(k)
	print(k)
	if k=='h' then 
		local success = hit() 
		if success then deal() end
	end
	if k=='escape' then love.event.quit() end
	if k=='e' then gameover() end
	if k=='r' then rules() end
end


-- window resizing 
function love.keyreleased(k)
	if k=='f' then resize() end
end

	window_state = 1

	function resize ()
		if window_state == 1 then
			love.window.updateMode(800,600,{fullscreen = false, resizable = false, highdpi = true})
			window_state = 2
			resize_ui(love.window.getMode())
		elseif window_state == 2 then
			love.window.updateMode( 1024, 768, {fullscreen = false, resizable = false, highdpi = true} )
			window_state = 3
			resize_ui(love.window.getMode())
		elseif window_state == 3 then
			love.window.updateMode( 640, 480, {fullscreen = false, resizable = false, highdpi = true} )
			window_state = 1
			resize_ui(love.window.getMode())
		end
	end


function resize_ui(w,h)
	local xy={}


	deck.w = w==640 and 70 or w==800 and 90 or w==1024 and 115
	deck.h = deck.w / 5 * 7

	local x = 12
	local space_between_cards = 8
	local vertical_space = 16
	w = w - x
	local len=math.floor(w/deck.w)
	local _rows = math.ceil(16/len)
	local n=1

	deck.x = x
	deck.y = vertical_space
	hand.x = x
	hand.w = w
	wrapWidth = w - 80
	if not font_20 then
		font_20 = love.graphics.newFont(20)
		love.graphics.setFont(font_20)
	end
	HelpText = nil -- Probably unnecessary, but not taking any chances
	HelpText = love.graphics.newText (font_20)
	HelpText:addf ("Press r to see the rules, e to end the game and see high scores. h to hit deck (deals card), escape to close the game.",
					wrapWidth, "left", deck.x, deck.y + deck.h)
					-- deck.x, deck.y + deck.h, wrapWidth, "left")


	local y = h - (h / 12)

	repeat
		for i=0,len-1 do
			if n >16 then break end
			xy[n] = 
			{	
				x = x + (space_between_cards * i) + (deck.w * i), 
				y = y - (deck.h * _rows) - ((_rows - 1) * vertical_space),
				dx = 0,
				dy = 0;
				w = deck.w;
				h = deck.h;
			}
			xy[n].x2 = xy[n].x + 2
			xy[n].y2 = xy[n].y + 2
			xy[n].w2 = xy[n].w - 4
			xy[n].h2 = xy[n].h - 4
			xy[n].current_x = xy[n].x2
			xy[n].current_y = xy[n].y2
			xy[n].current_w = xy[n].w2
			xy[n].current_h = xy[n].h2
			n = n + 1
		end
		_rows = _rows - 1
	until _rows <= 0
	hand.xy=xy
end

--xy represents top left corner - add w and h for bottom right corner
function love.mousepressed(x,y,button,isTouch,presses)

	if hand.xy[CARD_B] then
		hand.xy[CARD_B].dx=0
		hand.xy[CARD_B].dy=0
	end
	local e=isTouch and 10 or 0	-- extra space for fat fingers
	if x>deck.x-e and x<deck.x+deck.w+e
	and y>deck.y-e and y<deck.y+deck.h+e then
		local success = hit() 
		if success then deal() end
		-- local success = hit() and deal()
	elseif x>hand.x and x<hand.x+hand.w
	and y>hand.xy[1]['y'] and y<hand.xy[16]['y']+deck.h then
		for i in ipairs(hand) do
			if x>hand.xy[i].x and x<hand.xy[i].x+deck.w
			and y>hand.xy[i].y and y<hand.xy[i].y+deck.h then
				CARD_B = i -- selected card
				-- hand.selectedAnimationState = 'one'
				card_tween = Tween.new(0.1, hand.xy[i], 
					{
						current_x = hand.xy[i].x2 + 2;
						current_y = hand.xy[i].y2 + 2;
						current_w = hand.xy[i].w2 - 4,
						current_h = hand.xy[i].h2 - 4;
					}, Tween.easing.cubicOutTween)
				break
			end
		end
	end
end

--xy represents top left corner - add w and h for bottom right corner
function love.mousemoved(x,y,dx,dy,istouch)
	if hand.xy[CARD_B] then
		hand.xy[CARD_B].dx = hand.xy[CARD_B].dx + dx
		hand.xy[CARD_B].dy = hand.xy[CARD_B].dy + dy
		if x>hand.x and x<hand.x+hand.w
		and y>hand.xy[1]['y'] and y<hand.xy[16]['y']+deck.h then
			for i in ipairs(hand) do
				if x>hand.xy[i].x and x<hand.xy[i].x+deck.w
				and y>hand.xy[i].y and y<hand.xy[i].y+deck.h then
					CARD_A = i -- destination card
					break
				end
			end
		end
	end
end

--xy represents top left corner - add w and h for bottom right corner
function love.mousereleased(x,y,button,isTouch,presses)

	if hand[CARD_B] then
		hand.xy[CARD_B].dx = 0
		hand.xy[CARD_B].dy = 0
		card_tween:reset()
		if x>hand.x and x<hand.x+hand.w
		and y>hand.xy[1]['y'] and y<hand.xy[16]['y']+deck.h then
			for i in ipairs(hand) do
				if x>hand.xy[i].x and x<hand.xy[i].x+deck.w
				and y>hand.xy[i].y and y<hand.xy[i].y+deck.h then
					CARD_A = i
					hand.xy[CARD_B].dx = 0
					hand.xy[CARD_B].dy = 0

					play()
					CARD_A,CARD_B = 0,0
					break
				end
			end
		end
		CARD_B = 0
		CARD_A = 0

	end
end
